package com.huimv.admin.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.admin.common.utils.Result;
import com.huimv.admin.common.utils.ResultCode;
import com.huimv.admin.entity.CameraArea;
import com.huimv.admin.entity.CameraBase;
import com.huimv.admin.entity.hkwsdto.UnitDto1;
import com.huimv.admin.mapper.CameraAreaMapper;
import com.huimv.admin.mapper.CameraBaseMapper;
import com.huimv.admin.service.ICameraAreaService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-02-16
 */
@Service
public class CameraAreaServiceImpl extends ServiceImpl<CameraAreaMapper, CameraArea> implements ICameraAreaService {
    @Autowired
    private CameraBaseMapper cameraMapper;


    @Override
    public Result cameraList(Map<String, Object> params) {

        Integer current = (Integer) params.get("current");
        Integer size = (Integer) params.get("size");
        String areaName = (String) params.get("areaName");
        Integer farmId = (Integer) params.get("farmId");

        IPage<CameraArea> list = page(new Page<>(current, size), new QueryWrapper<CameraArea>().like(StringUtils.isNotBlank(areaName), "area_name", areaName).eq("farm_id", farmId));
        return new Result(ResultCode.SUCCESS, list);
    }

    @Override
    public Result removeIds(List<Integer> ids) {
        for (Integer id : ids) {
            CameraArea byId = this.getById(id);

            Integer areaId = cameraMapper.selectCount(new QueryWrapper<CameraBase>().eq("area_id", id));
            if (areaId > 0) {
                return new Result(10001, "删除失败,区域" + byId.getAreaName() + "仍然存在摄像头", false);
            }
        }
        this.removeByIds(ids);
        return new Result(10000, "删除成功", true);
    }

    @Override
    public Result lsitAndCamera(Integer farmId) {
        List endList = new ArrayList();

        List<CameraArea> cameraAreaList = this.list(new QueryWrapper<CameraArea>().eq("farm_id", farmId));

        for (CameraArea cameraArea : cameraAreaList) {
            Map map = new HashMap();
            map.put("cameraName", cameraArea.getAreaName());
            map.put("id", cameraArea.getId());
            map.put("cameraList", cameraMapper.selectList(new QueryWrapper<CameraBase>().eq("area_id", cameraArea.getId())));
            endList.add(map);
        }


        return new Result(ResultCode.SUCCESS, endList);
    }

    @Override
    public void sync(Map<String, Integer> params,List<UnitDto1> list) {
        Integer farmId = params.get("farmId");
        //同步，先删除
        QueryWrapper<CameraArea> wrapper = new QueryWrapper<>();
        //TODO 正康猪业 先这样做
        wrapper.eq("farm_id",farmId);
        this.remove(wrapper);
        for (UnitDto1 unitDto1 : list) {
            CameraArea cameraArea  = new CameraArea();
            BeanUtil.copyProperties(unitDto1,cameraArea);
            cameraArea.setAreaName(unitDto1.getName());
            cameraArea.setFarmId(farmId);
            cameraArea.setPublicUrl("61.153.248.106:6713");
            this.save(cameraArea);
        }

    }

}
