package com.huimv.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.admin.common.utils.Result;
import com.huimv.admin.common.utils.ResultCode;
import com.huimv.admin.entity.CameraFunctionArea;
import com.huimv.admin.mapper.CameraFunctionAreaMapper;
import com.huimv.admin.mapper.CameraFunctionMapper;
import com.huimv.admin.service.ICameraFunctionAreaService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-02-17
 */
@Service
public class CameraFunctionAreaServiceImpl extends ServiceImpl<CameraFunctionAreaMapper, CameraFunctionArea> implements ICameraFunctionAreaService {
    @Autowired
    private CameraFunctionAreaMapper cameraFunctionAreaMapper;

    @Autowired
    private CameraFunctionMapper cameraFunctionMapper;

    @Override
    public Result cameraList(Map<String, Object> params) {
        Integer current = (Integer) params.get("current");
        Integer size = (Integer) params.get("size");
        String functionaName = (String) params.get("functionaName");
        String farmId = (String) params.get("farmId");

        IPage<CameraFunctionArea> list = page(new Page<>(current, size), new QueryWrapper<CameraFunctionArea>().like(StringUtils.isNotBlank(functionaName), "area_name", functionaName).eq("farm_id", farmId));
        return new Result(ResultCode.SUCCESS, list);
    }

    @Override
    @Transactional
    public Result removeIds(List<Integer> ids) {
        for (Integer id : ids) {
            CameraFunctionArea byId = this.getById(id);
            if (StringUtils.isNotBlank(byId.getFunctionIds()) ) {
                return new Result(10001, "删除失败," + byId.getFunctionName() + "仍然存在区域", false);
            }
        }
        this.removeByIds(ids);
        return new Result(10000, "删除成功", true);
    }

    @Override
    public Result addFunction(Map<String, String> params) {
        String functionAreaId = params.get("functionAreaId");
        String functionIds = params.get("functionIds");
        CameraFunctionArea cameraFunctionArea = new CameraFunctionArea();
        cameraFunctionArea.setId(Integer.parseInt(functionAreaId));
        cameraFunctionArea.setFunctionIds(functionIds);
        this.updateById(cameraFunctionArea);
        return new Result(10000, "添加成功", true);
    }
}
