package com.huimv.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.admin.common.utils.Result;
import com.huimv.admin.common.utils.ResultCode;
import com.huimv.admin.entity.EnvDeviceMaintain;
import com.huimv.admin.mapper.EnvDeviceMaintainMapper;
import com.huimv.admin.service.IEnvDeviceMaintainService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 * 设备维修记录 服务实现类
 * </p>
 *
 * @author author
 * @since 2023-02-13
 */
@Service
public class EnvDeviceMaintainServiceImpl extends ServiceImpl<EnvDeviceMaintainMapper, EnvDeviceMaintain> implements IEnvDeviceMaintainService {

    @Autowired
    private EnvDeviceMaintainMapper envDeviceMaintainMapper;

    @Override
    public Result list(HttpServletRequest httpServletRequest, Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String deviceId = paramsMap.get("deviceId");
        QueryWrapper<EnvDeviceMaintain> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("device_id", deviceId).eq("farm_id", farmId);
        return new Result(ResultCode.SUCCESS,envDeviceMaintainMapper.selectOne(queryWrapper));
    }

}
